<template>
    <div>
        <main style="text-align: center;">
            <h3>Playlists</h3>

            <div class="row text-white mb-5" style="height: 50px">
                <div class="col"></div>
                <div class="col"></div>
                <div class="col"></div>
                <div class="col">
                    <svg xmlns="http://www.w3.org/2000/svg" width="35" height="35" fill="currentColor" class="bi bi-plus add-playlist" v-if="!show" @click="show = !show" viewBox="0 0 16 16">
                        <path d="M8 4a.5.5 0 0 1 .5.5v3h3a.5.5 0 0 1 0 1h-3v3a.5.5 0 0 1-1 0v-3h-3a.5.5 0 0 1 0-1h3v-3A.5.5 0 0 1 8 4z"/>
                    </svg>
                    <svg xmlns="http://www.w3.org/2000/svg" width="25" height="25" fill="currentColor" class="bi bi-x-circle add-playlist" v-else @click="show = !show" viewBox="0 0 16 16">
                        <path d="M8 15A7 7 0 1 1 8 1a7 7 0 0 1 0 14zm0 1A8 8 0 1 0 8 0a8 8 0 0 0 0 16z"/>
                        <path d="M4.646 4.646a.5.5 0 0 1 .708 0L8 7.293l2.646-2.647a.5.5 0 0 1 .708.708L8.707 8l2.647 2.646a.5.5 0 0 1-.708.708L8 8.707l-2.646 2.647a.5.5 0 0 1-.708-.708L7.293 8 4.646 5.354a.5.5 0 0 1 0-.708z"/>
                    </svg>
                </div>
            </div>

            <transition name="add-playlist-form">
                <div v-if="show">
                    <div class="row text-white" style="height: 50px">
                        <div class="col"></div>
                        <div class="col">
                            <input type="text" class="form-control" v-model="playlistName" placeholder="Enter name..." required>
                        </div>
                        <div class="col"></div>
                    </div>
                    <div class="row text-white" style="height: 50px">
                        <div class="col"></div>
                        <div class="col">
                            <button class="btn btn-outline-success form-control" v-if="playlistName !== ''" @click="addPlaylist(playlistName)">Add</button>
                        </div>
                        <div class="col"></div>
                    </div>
                </div>
            </transition>

            <transition name="slide-fade">
                <div class="row playlists" v-if="playlists.length !== 0">
                    <div class="col-md-6 col-lg-3 col-sm-12 mb-3" v-for="playlist in playlists">
                        <router-link
                            :to="{name: 'playlist-songs', params: {id: playlist.id}}"
                            class="text-white"
                            style="text-decoration: none"
                        >
                            <div class="card flex-md-row mb-4 box-shadow h-md-250 w-100 h-100 bg-dark playlist-bg">
                                <div class="card-body d-flex flex-column align-items-start">
                                    <strong class="d-inline-block mb-2">MyMusic</strong>
                                    <h3 class="mb-0">
                                        <strong>
                                            {{ playlist.name }}
                                        </strong>
                                    </h3>
                                    <hr>
                                    <button class="btn btn-outline-success" @click="playAll(playlist.id)">
                                        &#9658; <small>ALL</small>
                                    </button>
                                </div>
                            </div>
                        </router-link>
                    </div>
                </div>
            </transition>

        </main>
    </div>
</template>

<script>
export default {
    name: "Playlists",

    data() {
        return {
            pager: {},
            index: 0,
            indexCurrentPage: 1,
            show: false,
            playlistName: '',
            playlists: []
        }
    },

    created() {
        this.getPlaylists();
    },

    computed: {
        songs() {
            return this.pager.data || [];
        },
        current() {
            return this.songs[this.index] || [];
        },
        //     currentPage(){
        //         return this.indexCurrentPage = this.pager.current_page;
        //     }
        },

        beforeDestroy() {
            clearInterval();
        },

        methods: {

            addPlaylist(name) {
                axios
                    .post('/api/add-playlist', {name: name})
                    .then(({data}) => {
                        this.playlistName = '';
                        this.getPlaylists();
                    })
                    .catch(error => console.log(error.response.data));
            },

            getPlaylists() {
                axios
                    .get('/api/get/play-lists')
                    .then(({data}) => {
                        this.playlists = data;
                    })
                    .catch(error => console.log(error.response.data));
            },

            playAll(id) {
                this.$emit('playAll', {playlistId: id});
            }
        }
}
</script>

<style scoped>
.playlists {
    margin-bottom: 200px;
}
</style>
